// MC9090_TestDlg.cpp : Implementierungsdatei
//

#include "stdafx.h"
#include "MC9090_Test.h"
#include "MC9090_TestDlg.h"
#include "feisc.h"
#include "fecom.h"

#define WM_USER_CTS						(WM_USER + 5)
#define WM_USER_RTS						(WM_USER + 6)
#define WM_USER_DEVICE_DISCONNECT		(WM_USER + 7)
#define WM_USER_DEVICE_CONNECT			(WM_USER + 8)
#define WM_USER_NEW_DATA				(WM_USER + 9)

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CMC9090_TestDlg-Dialogfeld

CMC9090_TestDlg::CMC9090_TestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMC9090_TestDlg::IDD, pParent)
	, m_bCTS(FALSE)
{
	int iReaderHnd = 0;

	m_iPortHnd = 0;
	m_iReaderHnd = 0;

	iReaderHnd = FEISC_NewReader(0);
	if(iReaderHnd > 0)
		m_iReaderHnd = iReaderHnd;

	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMC9090_TestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Check(pDX, IDC_CHK_CTS, m_bCTS);
	DDX_Control(pDX, IDC_EVENT_LIST, m_EventList);
}

BEGIN_MESSAGE_MAP(CMC9090_TestDlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	ON_WM_SIZE()
#endif
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BTN_OPEN, &CMC9090_TestDlg::OnBnClickedBtnOpen)
	ON_MESSAGE(WM_USER_CTS, OnCTSMessage)
	ON_MESSAGE(WM_USER_RTS, OnRTSMessage)
	ON_MESSAGE(WM_USER_DEVICE_CONNECT, OnConnect)
	ON_MESSAGE(WM_USER_DEVICE_DISCONNECT, OnDisConnect)
	ON_MESSAGE(WM_USER_NEW_DATA, OnNewMessage)
	ON_BN_CLICKED(IDC_BTN_0x65, &CMC9090_TestDlg::OnBnClickedBtn0x65)
	ON_BN_CLICKED(IDC_BTN_INVENTORY, &CMC9090_TestDlg::OnBnClickedBtnInventory)
	ON_BN_CLICKED(IDC_BTN_WRITE_EPC, &CMC9090_TestDlg::OnBnClickedBtnWriteEpc)
	ON_BN_CLICKED(IDC_BTN_WRITE_ACCESS_AND_KILL_PASSWORD, &CMC9090_TestDlg::OnBnClickedBtnWriteAccessAndKillPassword)
	ON_BN_CLICKED(IDC_BTN_LOCK_ACCESS_PASSWORD, &CMC9090_TestDlg::OnBnClickedBtnLockAccessPassword)
	ON_BN_CLICKED(IDC_BTN_KILL_TAG, &CMC9090_TestDlg::OnBnClickedBtnKillTag)
END_MESSAGE_MAP()


// CMC9090_TestDlg-Meldungshandler

BOOL CMC9090_TestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Symbol fr dieses Dialogfeld festlegen. Wird automatisch erledigt
	//  wenn das Hauptfenster der Anwendung kein Dialogfeld ist
	SetIcon(m_hIcon, TRUE);			// Groes Symbol verwenden
	SetIcon(m_hIcon, FALSE);		// Kleines Symbol verwenden

	// TODO: Hier zustzliche Initialisierung einfgen
	
	return TRUE;  // Geben Sie TRUE zurck, auer ein Steuerelement soll den Fokus erhalten
}

#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CMC9090_TestDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
	if (AfxIsDRAEnabled())
	{
		DRA::RelayoutDialog(
			AfxGetResourceHandle(), 
			this->m_hWnd, 
			DRA::GetDisplayMode() != DRA::Portrait ? 
			MAKEINTRESOURCE(IDD_MC9090_TEST_DIALOG_WIDE) : 
			MAKEINTRESOURCE(IDD_MC9090_TEST_DIALOG));
	}
}
#endif


void CMC9090_TestDlg::OnBnClickedBtnOpen()
{
	int iError = 0;
	int iPortHnd = 0;
	char cPortHnd[16];

	if(m_iPortHnd > 0)
	{
		FECOM_ClosePort(m_iPortHnd);
		GetDlgItem(IDC_BTN_OPEN)->SetWindowTextW(_T("OpenPort"));
		m_iPortHnd = 0;

		if(m_iReaderHnd > 0)
		{
			FEISC_SetReaderPara(m_iReaderHnd, "PortHnd", "0");
		}

		return;
	}

	// open the port
	iPortHnd = FECOM_OpenPort("1");
	if(iPortHnd < 0)
		return;

	// set port parameters
	FECOM_SetPortPara(iPortHnd, "Baud", "38400");
	FECOM_SetPortPara(iPortHnd, "Frame", "8E1");
	FECOM_SetPortPara(iPortHnd, "Timeout", "1000");

	// install event handler for port close messages
	m_FecomInit.uiFlag	= FECOM_WND_HWND;
	m_FecomInit.uiUse	= FECOM_PORT_CLOSED_EVENT;
	m_FecomInit.uiMsg	= WM_USER_DEVICE_DISCONNECT;
	m_FecomInit.hwndWnd	= this->GetSafeHwnd();
	iError = FECOM_AddEventHandler(iPortHnd, &m_FecomInit);
	if (iError < 0)
	{
		FECOM_ClosePort(iPortHnd);
		return;
	}

	// install event handler for port open messages
	m_FecomInit.uiFlag	= FECOM_WND_HWND;
	m_FecomInit.uiUse	= FECOM_PORT_REOPEN_EVENT;
	m_FecomInit.uiMsg	= WM_USER_DEVICE_CONNECT;
	m_FecomInit.hwndWnd	= this->GetSafeHwnd();
	iError = FECOM_AddEventHandler(iPortHnd, &m_FecomInit);
	if (iError < 0)
	{
		FECOM_ClosePort(iPortHnd);
		return;
	}

	// install event handler for CTS
	m_FecomInit.uiFlag = FECOM_WND_HWND;
	m_FecomInit.uiUse = FECOM_CTS_EVENT;
	m_FecomInit.uiMsg = WM_USER_CTS;
	m_FecomInit.hwndWnd = this->GetSafeHwnd();
	iError = FECOM_AddEventHandler(iPortHnd, &m_FecomInit);
	if (iError < 0)
	{
		FECOM_ClosePort(iPortHnd);
		return;
	}

	// install event handler for RTS
	m_FecomInit.uiFlag = FECOM_WND_HWND;
	m_FecomInit.uiUse = FECOM_RTS_EVENT;
	m_FecomInit.uiMsg = WM_USER_RTS;
	m_FecomInit.hwndWnd = this->GetSafeHwnd();
	iError = FECOM_AddEventHandler(iPortHnd, &m_FecomInit);
	if (iError < 0)
	{
		FECOM_ClosePort(iPortHnd);
		return;
	}

	if(m_iReaderHnd > 0)
	{
		sprintf(cPortHnd, "%d", iPortHnd);
		FEISC_SetReaderPara(m_iReaderHnd, "PortHnd", cPortHnd);
//		FEISC_SetReaderPara(m_iReaderHnd, "PowerOnTime", "5"); // example to modify the power on time
//		FEISC_SetReaderPara(m_iReaderHnd, "WAITAFTERPOWERON", "1000");
//		FEISC_SetReaderPara(m_iReaderHnd, "LogProt", "1");
//		FEISC_SetReaderPara(m_iReaderHnd, "LogFile", "1");

		// install event handler for protocol messages
		m_FeiscInit.uiFlag	= FEISC_WND_HWND;
		m_FeiscInit.uiUse	= FEISC_PRT_EVENT;
		m_FeiscInit.uiMsg	= WM_USER_NEW_DATA;
		m_FeiscInit.hwndWnd	= this->GetSafeHwnd();
		iError = FEISC_AddEventHandler(m_iReaderHnd, &m_FeiscInit);
		if (iError < 0)
		{
			m_EventList.AddString(_T("FEISC_AddEventHandler failed"));
			m_EventList.SetTopIndex(m_EventList.GetCount() - 1);
		}
	}

	GetDlgItem(IDC_BTN_OPEN)->SetWindowTextW(_T("ClosePort"));
	m_iPortHnd = iPortHnd;
}

LRESULT CMC9090_TestDlg::OnCTSMessage(WPARAM wParam,LPARAM lParam)
{
	if(wParam == 1)
	{
		if(lParam == 0)
			m_bCTS = FALSE;
		else
			m_bCTS = TRUE;

		UpdateData(FALSE);
	}

	return TRUE;
}

LRESULT CMC9090_TestDlg::OnRTSMessage(WPARAM wParam,LPARAM lParam)
{
	if(wParam == 1)
	{
		if(lParam == 0)
		{
			m_EventList.AddString(_T("Power Down"));
			m_EventList.SetTopIndex(m_EventList.GetCount() - 1);
		}
		else
		{
			m_EventList.AddString(_T("Power Up"));
			m_EventList.SetTopIndex(m_EventList.GetCount() - 1);
		}

		UpdateData(FALSE);
	}

	return TRUE;
}

LRESULT CMC9090_TestDlg::OnNewMessage(WPARAM wParam,LPARAM lParam)
{
	if(wParam == 0)
		return TRUE;

	CString sMsg;
	sMsg.Format(_T("%S"), (LPCTSTR)wParam);
	sMsg += _T("\r\n");
	m_EventList.AddString(sMsg);
	m_EventList.SetTopIndex(m_EventList.GetCount() - 1);

	UpdateData(FALSE);

	return TRUE;
}

LRESULT CMC9090_TestDlg::OnConnect(WPARAM wParam,LPARAM lParam)
{
	m_EventList.AddString(_T("Open Port"));
	m_EventList.SetTopIndex(m_EventList.GetCount() - 1);
	return TRUE;
}

LRESULT CMC9090_TestDlg::OnDisConnect(WPARAM wParam,LPARAM lParam)
{
	m_EventList.AddString(_T("Close Port"));
	m_EventList.SetTopIndex(m_EventList.GetCount() - 1);
	return TRUE;
}

void CMC9090_TestDlg::OnBnClickedBtn0x65()
{
	unsigned char cVersion[64];
	char cErrorText[256];
	CString sMsg;
	int iError = 0;

	iError = FEISC_0x65_SoftVersion( m_iReaderHnd, 0, &cVersion[0], 1 );
	if(iError < 0)
	{
		if( iError > -1100 && iError <= -1000 )
		{
			FECOM_GetErrorText(iError, cErrorText);
			sMsg.Format(_T("%S"), cErrorText);
			m_EventList.AddString(sMsg);
			m_EventList.SetTopIndex(m_EventList.GetCount() - 1);
		}
		else if( iError > -4100 && iError < -4000 )
		{
			FEISC_GetErrorText(iError, cErrorText);
			sMsg.Format(_T("%S"), cErrorText);
			m_EventList.AddString(sMsg);
			m_EventList.SetTopIndex(m_EventList.GetCount() - 1);
		}
	}
	else if(iError > 0)
	{
		FEISC_GetStatusText(iError, cErrorText);
		sMsg.Format(_T("%S"), cErrorText);
		m_EventList.AddString(sMsg);
		m_EventList.SetTopIndex(m_EventList.GetCount() - 1);
	}
	else
	{
		sMsg.Format(_T("%S"), cVersion);
		m_EventList.AddString(sMsg);
		m_EventList.SetTopIndex(m_EventList.GetCount() - 1);
	}
}

void CMC9090_TestDlg::OnBnClickedBtnInventory()
{
	if(m_iReaderHnd <= 0)
		return;

	Inventory();
}

void CMC9090_TestDlg::OnBnClickedBtnWriteEpc()
{
	if(m_iReaderHnd <= 0)
		return;

	WriteEPC();
}

void CMC9090_TestDlg::OnBnClickedBtnWriteAccessAndKillPassword()
{
	if(m_iReaderHnd <= 0)
		return;

	WriteAccessAndKillPassword();
}

void CMC9090_TestDlg::OnBnClickedBtnLockAccessPassword()
{
	if(m_iReaderHnd <= 0)
		return;

	LockAccessPassword();
}

void CMC9090_TestDlg::OnBnClickedBtnKillTag()
{
	if(m_iReaderHnd <= 0)
		return;

	KillTag();
}

int CMC9090_TestDlg::Inventory()
{
	char cErrorText[256];
	CString sMsg, sTmp;
	int iError = 0;

	// Inventory
	m_iReqLen = 0;
	m_iRspLen = 0;
	m_cReqData[m_iReqLen++] = 0x01; // command byte
	m_cReqData[m_iReqLen++] = 0x00; // mode byte

	iError = FEISC_0xB0_ISOCmd( m_iReaderHnd, 0, m_cReqData, m_iReqLen, m_cRspData, &m_iRspLen, 0 );
	if(iError < 0)
	{
		if( iError > -1100 && iError <= -1000 )
		{
			FECOM_GetErrorText(iError, cErrorText);
			sMsg.Format(_T("%S"), cErrorText);
			m_EventList.AddString(sMsg);
			m_EventList.SetTopIndex(m_EventList.GetCount() - 1);
		}
		else if( iError > -4100 && iError < -4000 )
		{
			FEISC_GetErrorText(iError, cErrorText);
			sMsg.Format(_T("%S"), cErrorText);
			m_EventList.AddString(sMsg);
			m_EventList.SetTopIndex(m_EventList.GetCount() - 1);
		}
	}
	else if(iError > 0)
	{
		FEISC_GetStatusText(iError, cErrorText);
		sMsg.Format(_T("%S"), cErrorText);
		m_EventList.AddString(sMsg);
		m_EventList.SetTopIndex(m_EventList.GetCount() - 1);
	}
	else
	{
		sMsg = "";
		for(int i=0; i<m_iRspLen; i++)
		{
			sTmp.Format(_T("%02X "), m_cRspData[i]);
			sMsg += sTmp;
		}
		m_EventList.AddString(sMsg);
		m_EventList.SetTopIndex(m_EventList.GetCount() - 1);

		// save last received 96-Bit (12 byte) EPC number
		m_cEpc[0] = m_cRspData[6];
		m_cEpc[1] = m_cRspData[7];
		m_cEpc[2] = m_cRspData[8];
		m_cEpc[3] = m_cRspData[9];
		m_cEpc[4] = m_cRspData[10];
		m_cEpc[5] = m_cRspData[11];
		m_cEpc[6] = m_cRspData[12];
		m_cEpc[7] = m_cRspData[13];
		m_cEpc[8] = m_cRspData[14];
		m_cEpc[9] = m_cRspData[15];
		m_cEpc[10] = m_cRspData[16];
		m_cEpc[11] = m_cRspData[17];
	}

	return iError;
}

int CMC9090_TestDlg::WriteEPC()
{
	char cErrorText[256];
	CString sMsg, sTmp;
	int iError = 0;

	m_iReqLen = 0;
	m_iRspLen = 0;
	m_cReqData[m_iReqLen++] = 0x24; // command byte
	m_cReqData[m_iReqLen++] = 0x31; // mode byte (extended address mode, UID length flag, addressed mode)
	m_cReqData[m_iReqLen++] = 0x0C; // EPC length (in number of bytes)
	m_cReqData[m_iReqLen++] = m_cEpc[0]; // EPC from last Inventory
	m_cReqData[m_iReqLen++] = m_cEpc[1];
	m_cReqData[m_iReqLen++] = m_cEpc[2];
	m_cReqData[m_iReqLen++] = m_cEpc[3];
	m_cReqData[m_iReqLen++] = m_cEpc[4];
	m_cReqData[m_iReqLen++] = m_cEpc[5];
	m_cReqData[m_iReqLen++] = m_cEpc[6];
	m_cReqData[m_iReqLen++] = m_cEpc[7];
	m_cReqData[m_iReqLen++] = m_cEpc[8];
	m_cReqData[m_iReqLen++] = m_cEpc[9];
	m_cReqData[m_iReqLen++] = m_cEpc[10];
	m_cReqData[m_iReqLen++] = m_cEpc[11];
	m_cReqData[m_iReqLen++] = 0x01; // bank number (EPC memory bank)
	m_cReqData[m_iReqLen++] = 0x00; // MSB datablock address
	m_cReqData[m_iReqLen++] = 0x02; // LSB datablock address
	m_cReqData[m_iReqLen++] = 0x06; // number of datablocks
	m_cReqData[m_iReqLen++] = 0x02; // datablock size
	m_cReqData[m_iReqLen++] = 0x11; // first byte new EPC
	m_cReqData[m_iReqLen++] = 0x22;
	m_cReqData[m_iReqLen++] = 0x33;
	m_cReqData[m_iReqLen++] = 0x44;
	m_cReqData[m_iReqLen++] = 0x55;
	m_cReqData[m_iReqLen++] = 0x66;
	m_cReqData[m_iReqLen++] = 0x77;
	m_cReqData[m_iReqLen++] = 0x88;
	m_cReqData[m_iReqLen++] = 0x99;
	m_cReqData[m_iReqLen++] = 0xAA;
	m_cReqData[m_iReqLen++] = 0xBB;
	m_cReqData[m_iReqLen++] = 0xCC; // last byte new EPC

	iError = FEISC_0xB0_ISOCmd( m_iReaderHnd, 0, m_cReqData, m_iReqLen, m_cRspData, &m_iRspLen, 0 );
	if(iError < 0)
	{
		if( iError > -1100 && iError <= -1000 )
		{
			FECOM_GetErrorText(iError, cErrorText);
			sMsg.Format(_T("%S"), cErrorText);
			m_EventList.AddString(sMsg);
			m_EventList.SetTopIndex(m_EventList.GetCount() - 1);
		}
		else if( iError > -4100 && iError < -4000 )
		{
			FEISC_GetErrorText(iError, cErrorText);
			sMsg.Format(_T("%S"), cErrorText);
			m_EventList.AddString(sMsg);
			m_EventList.SetTopIndex(m_EventList.GetCount() - 1);
		}
	}
	else if(iError > 0)
	{
		FEISC_GetStatusText(iError, cErrorText);
		sMsg.Format(_T("%S"), cErrorText);
		m_EventList.AddString(sMsg);
		m_EventList.SetTopIndex(m_EventList.GetCount() - 1);
	}
	else
	{
		m_EventList.AddString("Write successful");
		m_EventList.SetTopIndex(m_EventList.GetCount() - 1);
	}

	return iError;
}

int CMC9090_TestDlg::WriteAccessAndKillPassword()
{
	char cErrorText[256];
	CString sMsg, sTmp;
	int iError = 0;

	m_iReqLen = 0;
	m_iRspLen = 0;
	m_cReqData[m_iReqLen++] = 0x24; // command byte
	m_cReqData[m_iReqLen++] = 0x31; // mode byte (extended address mode, UID length flag, addressed mode)
	m_cReqData[m_iReqLen++] = 0x0C; // EPC length (in number of bytes)
	m_cReqData[m_iReqLen++] = m_cEpc[0]; // EPC from last Inventory
	m_cReqData[m_iReqLen++] = m_cEpc[1];
	m_cReqData[m_iReqLen++] = m_cEpc[2];
	m_cReqData[m_iReqLen++] = m_cEpc[3];
	m_cReqData[m_iReqLen++] = m_cEpc[4];
	m_cReqData[m_iReqLen++] = m_cEpc[5];
	m_cReqData[m_iReqLen++] = m_cEpc[6];
	m_cReqData[m_iReqLen++] = m_cEpc[7];
	m_cReqData[m_iReqLen++] = m_cEpc[8];
	m_cReqData[m_iReqLen++] = m_cEpc[9];
	m_cReqData[m_iReqLen++] = m_cEpc[10];
	m_cReqData[m_iReqLen++] = m_cEpc[11];
	m_cReqData[m_iReqLen++] = 0x00; // bank number (Reserved memory bank)
	m_cReqData[m_iReqLen++] = 0x00; // MSB datablock address
	m_cReqData[m_iReqLen++] = 0x00; // LSB datablock address
	m_cReqData[m_iReqLen++] = 0x04; // number of datablocks
	m_cReqData[m_iReqLen++] = 0x02; // datablock size
	m_cReqData[m_iReqLen++] = 0x11; // first byte of kill password
	m_cReqData[m_iReqLen++] = 0x11;
	m_cReqData[m_iReqLen++] = 0x11;
	m_cReqData[m_iReqLen++] = 0x11; // last byte of kill password
	m_cReqData[m_iReqLen++] = 0x22; // first byte of access password
	m_cReqData[m_iReqLen++] = 0x22;
	m_cReqData[m_iReqLen++] = 0x22;
	m_cReqData[m_iReqLen++] = 0x22; // last byte of access password

	iError = FEISC_0xB0_ISOCmd( m_iReaderHnd, 0, m_cReqData, m_iReqLen, m_cRspData, &m_iRspLen, 0 );
	if(iError < 0)
	{
		if( iError > -1100 && iError <= -1000 )
		{
			FECOM_GetErrorText(iError, cErrorText);
			sMsg.Format(_T("%S"), cErrorText);
			m_EventList.AddString(sMsg);
			m_EventList.SetTopIndex(m_EventList.GetCount() - 1);
		}
		else if( iError > -4100 && iError < -4000 )
		{
			FEISC_GetErrorText(iError, cErrorText);
			sMsg.Format(_T("%S"), cErrorText);
			m_EventList.AddString(sMsg);
			m_EventList.SetTopIndex(m_EventList.GetCount() - 1);
		}
	}
	else if(iError > 0)
	{
		FEISC_GetStatusText(iError, cErrorText);
		sMsg.Format(_T("%S"), cErrorText);
		m_EventList.AddString(sMsg);
		m_EventList.SetTopIndex(m_EventList.GetCount() - 1);
	}
	else
	{
		m_EventList.AddString("Write successful");
		m_EventList.SetTopIndex(m_EventList.GetCount() - 1);
	}

	return iError;
}

int CMC9090_TestDlg::LockAccessPassword()
{
	char cErrorText[256];
	CString sMsg, sTmp;
	int iError = 0;

	m_iReqLen = 0;
	m_iRspLen = 0;
	m_cReqData[m_iReqLen++] = 0x22; // command byte
	m_cReqData[m_iReqLen++] = 0x11; // mode byte (UID length flag, addressed mode)
	m_cReqData[m_iReqLen++] = 0x0C; // EPC length (in number of bytes)
	m_cReqData[m_iReqLen++] = m_cEpc[0]; // EPC from last Inventory
	m_cReqData[m_iReqLen++] = m_cEpc[1];
	m_cReqData[m_iReqLen++] = m_cEpc[2];
	m_cReqData[m_iReqLen++] = m_cEpc[3];
	m_cReqData[m_iReqLen++] = m_cEpc[4];
	m_cReqData[m_iReqLen++] = m_cEpc[5];
	m_cReqData[m_iReqLen++] = m_cEpc[6];
	m_cReqData[m_iReqLen++] = m_cEpc[7];
	m_cReqData[m_iReqLen++] = m_cEpc[8];
	m_cReqData[m_iReqLen++] = m_cEpc[9];
	m_cReqData[m_iReqLen++] = m_cEpc[10];
	m_cReqData[m_iReqLen++] = m_cEpc[11];
	m_cReqData[m_iReqLen++] = 0x84; // EPC type
	m_cReqData[m_iReqLen++] = 0x03; // length of lock data
	m_cReqData[m_iReqLen++] = 0x20; // lock data: temporary lock of Access Password in reserved bank
	m_cReqData[m_iReqLen++] = 0x08; // lock data: temporary lock of Access Password in reserved bank
	m_cReqData[m_iReqLen++] = 0x00; // lock data: temporary lock of Access Password in reserved bank
	m_cReqData[m_iReqLen++] = 0x04; // length of password
	m_cReqData[m_iReqLen++] = 0x22; // first byte of access password
	m_cReqData[m_iReqLen++] = 0x22;
	m_cReqData[m_iReqLen++] = 0x22;
	m_cReqData[m_iReqLen++] = 0x22; // last byte of access password
	iError = FEISC_0xB3_EPCCmd( m_iReaderHnd, 0, m_cReqData, m_iReqLen, m_cRspData, &m_iRspLen, 0 );
	if(iError < 0)
	{
		if( iError > -1100 && iError <= -1000 )
		{
			FECOM_GetErrorText(iError, cErrorText);
			sMsg.Format(_T("%S"), cErrorText);
			m_EventList.AddString(sMsg);
			m_EventList.SetTopIndex(m_EventList.GetCount() - 1);
		}
		else if( iError > -4100 && iError < -4000 )
		{
			FEISC_GetErrorText(iError, cErrorText);
			sMsg.Format(_T("%S"), cErrorText);
			m_EventList.AddString(sMsg);
			m_EventList.SetTopIndex(m_EventList.GetCount() - 1);
		}
	}
	else if(iError > 0)
	{
		FEISC_GetStatusText(iError, cErrorText);
		sMsg.Format(_T("%S"), cErrorText);
		m_EventList.AddString(sMsg);
		m_EventList.SetTopIndex(m_EventList.GetCount() - 1);
	}
	else
	{
		sMsg = "";
		for(int i=0; i<m_iRspLen; i++)
		{
			sTmp.Format(_T("%02X "), m_cRspData[i]);
			sMsg += sTmp;
		}
		m_EventList.AddString(sMsg);
		m_EventList.SetTopIndex(m_EventList.GetCount() - 1);
	}

	return iError;
}

int CMC9090_TestDlg::KillTag()
{
	char cErrorText[256];
	CString sMsg, sTmp;
	int iError = 0;

	m_iReqLen = 0;
	m_iRspLen = 0;
	m_cReqData[m_iReqLen++] = 0x18; // command byte
	m_cReqData[m_iReqLen++] = 0x11; // mode byte (UID length flag, addressed mode)
	m_cReqData[m_iReqLen++] = 0x0C; // EPC length (in number of bytes)
	m_cReqData[m_iReqLen++] = m_cEpc[0]; // EPC from last Inventory
	m_cReqData[m_iReqLen++] = m_cEpc[1];
	m_cReqData[m_iReqLen++] = m_cEpc[2];
	m_cReqData[m_iReqLen++] = m_cEpc[3];
	m_cReqData[m_iReqLen++] = m_cEpc[4];
	m_cReqData[m_iReqLen++] = m_cEpc[5];
	m_cReqData[m_iReqLen++] = m_cEpc[6];
	m_cReqData[m_iReqLen++] = m_cEpc[7];
	m_cReqData[m_iReqLen++] = m_cEpc[8];
	m_cReqData[m_iReqLen++] = m_cEpc[9];
	m_cReqData[m_iReqLen++] = m_cEpc[10];
	m_cReqData[m_iReqLen++] = m_cEpc[11];
	m_cReqData[m_iReqLen++] = 0x04; // length of password
	m_cReqData[m_iReqLen++] = 0x11; // first byte of kill password
	m_cReqData[m_iReqLen++] = 0x11;
	m_cReqData[m_iReqLen++] = 0x11;
	m_cReqData[m_iReqLen++] = 0x11; // last byte of kill password
	iError = FEISC_0xB3_EPCCmd( m_iReaderHnd, 0, m_cReqData, m_iReqLen, m_cRspData, &m_iRspLen, 0 );
	if(iError < 0)
	{
		if( iError > -1100 && iError <= -1000 )
		{
			FECOM_GetErrorText(iError, cErrorText);
			sMsg.Format(_T("%S"), cErrorText);
			m_EventList.AddString(sMsg);
			m_EventList.SetTopIndex(m_EventList.GetCount() - 1);
		}
		else if( iError > -4100 && iError < -4000 )
		{
			FEISC_GetErrorText(iError, cErrorText);
			sMsg.Format(_T("%S"), cErrorText);
			m_EventList.AddString(sMsg);
			m_EventList.SetTopIndex(m_EventList.GetCount() - 1);
		}
	}
	else if(iError > 0)
	{
		FEISC_GetStatusText(iError, cErrorText);
		sMsg.Format(_T("%S"), cErrorText);
		m_EventList.AddString(sMsg);
		m_EventList.SetTopIndex(m_EventList.GetCount() - 1);
	}
	else
	{
		sMsg = "";
		for(int i=0; i<m_iRspLen; i++)
		{
			sTmp.Format(_T("%02X "), m_cRspData[i]);
			sMsg += sTmp;
		}
		m_EventList.AddString(sMsg);
		m_EventList.SetTopIndex(m_EventList.GetCount() - 1);
	}

	return iError;
}
